﻿Public Class Form1
    ' DECLARE A CONSTANT VARIABLE TO USED FOR DETECTING THE CTRL KEY WHEN IT 
    ' WAS PRESSED DURING THE DRAG OPERATION 
    Const MASKCTRL As Byte = 8

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'SET THE PROPERTIES OF THE PICTUREBOX FOR ALLOWING TO DROP.
        lpic.AllowDrop = True
        rpic.AllowDrop = True
    End Sub

    Private Sub PictureBox_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lpic.MouseDown, rpic.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim pictures As PictureBox = CType(sender, PictureBox)

            'IT WILL ACTIVATE THE DRAG AND DROP OPERATION
            If Not pictures.Image Is Nothing Then
                pictures.DoDragDrop(pictures.Image, DragDropEffects.Move Or DragDropEffects.Copy)
            End If
        End If
    End Sub

    Private Sub PictureBox_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lpic.DragEnter, rpic.DragEnter

        'CHECKING THE DRAG CONTENT TO MAKE SURE THAT, THE TYPE IS ACCURATE FOR THIS CONTROL
        If (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            'CHECKING IF THE CTRL KEY WAS PRESSED 
            'AND IF THE CTRL KEY IS PRESS PERFORM COPY AND IT IS NOT PERFORM MOVE.
            If (e.KeyState And MASKCTRL) = MASKCTRL Then

                e.Effect = DragDropEffects.Copy
            Else

                e.Effect = DragDropEffects.Move
            End If
        Else
            'THE THE DROP EFFECT IS REJECTED.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub PictureBox_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lpic.DragDrop, rpic.DragDrop

        'THE IMAGE WILL DISPLAY TO THE SELECTED PICTUREBOX.
        Dim PIC As PictureBox = CType(sender, PictureBox)
        PIC.Image = CType(e.Data.GetData(DataFormats.Bitmap), Bitmap)

        'IF THE PICTURE IN THE PICTUREBOX WAS MOVE, THE OTHER BOX BECOMES EMPTY.
        If (e.KeyState And MASKCTRL) <> MASKCTRL Then  'CHECKING THE CTRL KEY WAS NOT PRESSED.
            If sender Is lpic Then
                rpic.Image = Nothing
            Else
                lpic.Image = Nothing
            End If
        End If
    End Sub
End Class
